%This program initially starts the retinal growth, with the    MAY 2005 LHC
%UNdifferentiated cells starting to differentiate into their defined 
%ordered pattern (as seen in "seed")

%Note: 
%The inputs to this program are:   --> from Retinalgrowth.m program
%Dx, Dy for red diff (x,y) coords
%Ux, Uy for undiff (x,y) coords

%***********  IMPORTANT VARIABLES   **********************************
lsd = lambdaI/10.;  % Set standard deviation of a Gaussian  
a1 = 1;             % Amplitude value of signal at source cell (i.e., at coordinates of each differentiated cell)
%*********************************************************************

%THIS LOOP finds distance between each precursor cell and each differentiated cell 
%and calculates the summed inhibitory signal value being received from all
%of the differentiated cells to that one precursor cell.

diffcount = 0;
ims = zeros(1,numUndiff);
Val = zeros(1,numUndiff);
for iundiff = 1:numUndiff;
    Dist = sqrt([(Ux(iundiff) - Dx).^2 + (Uy(iundiff) - Dy).^2]);    % distance between the precursor cell and all differentiated cells
    Val(iundiff) = sum(-a1*exp(-Dist./(lambdaI + lsd * randn)));     % sum of signal strengths arising from all differentiated cells
    if Val(iundiff) > threshold
        diffcount = diffcount + 1;
        Dx = [Dx; Ux(iundiff)];      % add in the newly differentiated cells
        Dy = [Dy; Uy(iundiff)];
        Ux(iundiff) = 0;             % put zeroes into undifferentiated array for each cell that has differentiated
        Uy(iundiff) = 0;      
    end
end

% now remove the zeros from the Undiff'ed arrays
inew = 0;
for iclear = 1:numUndiff
    if Ux(iclear) ~= 0;  % this is a cell that _wasn't_ differentiated
        inew = inew + 1;  % so add it to new array
        Ux_new(inew) = Ux(iclear);
        Uy_new(inew) = Uy(iclear);
    end
end
clear Ux Uy;
Ux = Ux_new;
Uy = Uy_new;

clear Val

numUndiff = length(Ux); %This calculates new number of precursor cells 
numdiffAm = length(Dx); %This calculates new number of differentiated cells 

% Update these for new seed for the next round of model growth
Drho = sqrt([(Dx.^2)+(Dy.^2)]);
Dtheta = atan2(Dy,Dx);